# Process this file with automake to produce an input makefile.
#
# Copyright (C) 2013, 2014  Patrick "P. J." McDermott
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

include $(top_srcdir)/src/local.mk
include $(top_srcdir)/lib/local.mk
include $(top_srcdir)/lib/buildsystem/local.mk
include $(top_srcdir)/man/local.mk
include $(top_srcdir)/locale/local.mk
include $(top_srcdir)/archtab/local.mk
include $(top_srcdir)/tests/local.mk

MANUAL = Distribution Build System

KEY='2250 31F0 47FF E516 63ED  516F 1A45 9ECD E4D6 04BE'

helper_sources = opkhelper.sh

bin_SCRIPTS = $(bin_sources:.sh=)
pkgdata_SCRIPTS = $(pkgdata_sources:.sh=.sm)
pkgdatabuildsystem_SCRIPTS = $(pkgdatabuildsystem_sources:.sh=.sm)
man1_MANS = $(man1_sources:.1in=.1)
locale_MESSAGES = $(locale_sources:.sh=.ms)
helper_SCRIPTS = $(helper_sources:.sh=)
CLEANFILES = \
	$(bin_SCRIPTS) \
	$(pkgdata_SCRIPTS) \
	$(pkgdatabuildsystem_SCRIPTS) \
	$(man1_MANS) \
	$(locale_MESSAGES) \
	$(helper_SCRIPTS)
pkgdatabuildsystemdir = $(pkgdatadir)/buildsystem
archtabdir = $(pkgdatadir)/archtab
EXTRA_DIST = \
	COPYING.2 \
	COPYING.3 \
	autogen.sh \
	$(bin_sources) \
	$(pkgdata_sources) \
	$(pkgdatabuildsystem_sources) \
	$(man1_sources) \
	$(locale_sources) \
	$(archtab_sources) \
	$(tests) \
	tests/testlib.sh \
	$(helper_sources) \
	scripts/changelog2news.sh

SUFFIXES = .sh .sm .1in .1 .ms

textdomain = $$(printf '%s\n' '$(PACKAGE)' | sed -e 's|-|_|g')
do_subst = sed \
	-e 's|[@]PACKAGE[@]|$(PACKAGE)|g' \
	-e 's|[@]PACKAGE_NAME[@]|$(PACKAGE_NAME)|g' \
	-e 's|[@]PACKAGE_VERSION[@]|$(PACKAGE_VERSION)|g' \
	-e 's|[@]MANUAL[@]|$(MANUAL)|g' \
	-e 's|[@]SH[@]|$(SH)|g' \
	-e 's|[@]LIBOPKBUILD[@]|$(LIBOPKBUILD)|g' \
	-e 's|[@]READELF[@]|$(READELF)|g' \
	-e 's|[@]OPKG[@]|$(OPKG)|g' \
	-e 's|[@]multiarch_libdir[@]|$(multiarch_libdir)|g' \
	-e 's|[@]library_path[@]|$(library_path)|g' \
	-e 's|[@]bindir[@]|$(bindir)|g' \
	-e 's|[@]pkgdatadir[@]|$(pkgdatadir)|g' \
	-e 's|[@]localedir[@]|$(localedir)|g' \
	-e 's|[@]archtabdir[@]|$(archtabdir)|g'

all-local: $(locale_MESSAGES) $(archtab_sources)

wikiman_script = \
	H; \
	$${ \
		g; \
		s|^.*<h1[^>]*>\([^<]*\)</h1>|[[!meta title="\1"]]|; \
		s|<hr>\n*</body>.*$$||; \
		p; \
	};
wikiman: $(man1_MANS)
	set -e; \
	for f in $(man1_MANS); do \
		groff -m man -T html "$${f}" | sed -n '$(wikiman_script)' \
			>"$${f}.mdwn"; \
	done

install-data-local: $(locale_MESSAGES) $(archtab_sources)
	@$(NORMAL_INSTALL)
	for f in $(locale_MESSAGES); do \
		ff="$${f#*/}"; \
		dir="$(DESTDIR)$(localedir)/$${ff%.ms}/LC_MESSAGES"; \
		$(MKDIR_P) "$${dir}" || exit 1; \
		$(INSTALL_DATA) "$${f}" "$${dir}/$(textdomain).ms" || \
			exit $${?}; \
	done
	for f in $(archtab_sources); do \
		ff="$${f#*/}"; \
		dir="$(DESTDIR)$(archtabdir)/$${ff%/?*}"; \
		$(MKDIR_P) "$${dir}" || exit 1; \
		$(INSTALL_DATA) "$(top_srcdir)/$${f}" "$${dir}/$${ff#*/}" || \
			exit $${?}; \
	done

uninstall-local:
	@$(NORMAL_UNINSTALL)
	for f in $(locale_MESSAGES); do \
		ff="$${f#*/}"; \
		dir="$(DESTDIR)$(localedir)/$${ff%.ms}/LC_MESSAGES"; \
		rm -f "$${dir}/$(textdomain).ms"; \
	done
	for f in $(archtab_sources); do \
		ff="$${f#*/}"; \
		dir="$(DESTDIR)$(archtabdir)/$${ff%/?*}"; \
		rm -f "$${dir}/$${ff#*/}"; \
	done

uninstall-hook:
	for f in $(archtab_sources); do \
		ff="$${f#*/}"; \
		dir="$(DESTDIR)$(archtabdir)/$${ff%/?*}"; \
		if [ -d "$${dir}" ]; then \
			rmdir "$${dir}" || exit 1; \
		fi; \
	done
	for dir in \
			'$(DESTDIR)$(pkgdatabuildsystemdir)' \
			'$(DESTDIR)$(archtabdir)' \
			'$(DESTDIR)$(pkgdatadir)'; do \
		if [ -d "$${dir}" ]; then \
			rmdir "$${dir}"; \
		fi; \
	done

clean-local:
	rm -f man/*.*.mdwn

really-clean: distclean
	rm -Rf $(srcdir)/aclocal.m4 $(srcdir)/autom4te.cache/ \
		$(srcdir)/configure \
		$(srcdir)/build-aux/ $(srcdir)/INSTALL $(srcdir)/Makefile.in \
		$(srcdir)/ChangeLog

dist-hook:
	if [ -d '$(srcdir)/.git' ]; then \
		printf 'Generated file.  Do not edit.\n\n' \
			>'$(distdir)/ChangeLog~'; \
		git log --stat --color=never >>'$(distdir)/ChangeLog~'; \
		mv '$(distdir)/ChangeLog~' '$(distdir)/ChangeLog'; \
	fi

test:
	@set -e; \
	mkdir -p tests; \
	cd tests; \
	. '$(abs_top_srcdir)/tests/testlib.sh'; \
	PATH="$${PATH}:$(DESTDIR)$(bindir)"; \
	t_all=0; t_failed=0; \
	for t_test in $(tests); do \
		t_fail='false'; \
		. "$(abs_top_srcdir)/$${t_test}" >out 2>&1; \
		if "$${t_fail}"; then \
			printf 'FAIL: %s\n' "$${t_test#tests/}"; \
			cat out | sed 's/^/    /'; \
			t_failed=$$(($$t_failed + 1)); \
		else \
			printf 'PASS: %s\n' "$${t_test#tests/}"; \
		fi; \
		t_all=$$(($$t_all + 1)); \
		rm out; \
	done; \
	t_banner="$$(printf '%d out of %d tests failed' \
		$${t_failed} $${t_all})"; \
	t_l=$$(printf '%s\n' "$${t_banner}" | wc -c); \
	t_i=1; while [ "$${t_i}" -lt "$${t_l}" ]; do \
		printf '='; \
		t_i=$$(($$t_i + 1)); \
	done; \
	printf '\n%s\n' "$${t_banner}"; \
	t_i=1; while [ "$${t_i}" -lt "$${t_l}" ]; do \
		printf '='; \
		t_i=$$(($$t_i + 1)); \
	done; \
	printf '\n'; \
	[ $${t_failed} -eq 0 ]

release:
	sed "s/^Released: ????-??-??\$$/Released: $$(date '+%Y-%m-%d')/" \
		'$(srcdir)/NEWS' >'$(srcdir)/NEWS~'
	mv '$(srcdir)/NEWS~' '$(srcdir)/NEWS'
	$(MAKE) dist  # Not distcheck
	set -e; \
	export GIT_DIR='$(srcdir)/.git'; \
	export GIT_WORK_TREE='$(srcdir)'; \
	git commit -m 'NEWS: Release $(PACKAGE) $(VERSION)' -- NEWS; \
	git tag '$(PACKAGE)/$(VERSION)' HEAD; \
	git push --tags origin master:master
	md5sum $(DIST_ARCHIVES) >MD5SUMS
	sha256sum $(DIST_ARCHIVES) >SHA256SUMS
	set -e; \
	sigs=''; \
	for f in $(DIST_ARCHIVES); do \
		gpg --local-user $(KEY) --armor --sign $${f}; \
		sigs="$${sigs} $${f}.asc"; \
	done; \
	ssh files@files.proteanos.com mkdir -p files/pub/$(PACKAGE); \
	rsync -az --progress --stats $(DIST_ARCHIVES) $${sigs} \
		MD5SUMS SHA256SUMS \
		files@files.proteanos.com:files/pub/$(PACKAGE)/$(VERSION)/
	'$(srcdir)/scripts/announce-release.sh' \
		$(PACKAGE) $(VERSION) '$(PACKAGE_NAME)'

.sh:
	$(AM_V_GEN)$(MKDIR_P) "$$(dirname $@)"
	$(AM_V_at)$(do_subst) $< >$@
	$(AM_V_at)chmod a+x $@

.sh.sm:
	$(AM_V_GEN)$(MKDIR_P) "$$(dirname $@)"
	$(AM_V_at)$(do_subst) $< >$@

.1in.1:
	$(AM_V_GEN)$(MKDIR_P) "$$(dirname $@)"
	$(AM_V_at)$(do_subst) $< >$@

.sh.ms:
	$(AM_V_GEN)$(MKDIR_P) "$$(dirname $@)"
	$(AM_V_at)cp $< $@